// DS's posting and editing functions for LiveJournal.

if (parent.accountwindow) {
	LiveJournal = parent.LiveJournal;
	dsAccounts = parent.dsAccounts;
	var isSidebar = parent.isSidebar;
}

dsPosts = new Object();
var dsPrefs = new PrefsWrapper1("extensions.deepestSender.");

function Init() {
	// Main init function for the post/edit window.
	// In: Nothing.
	// Out: Nothing.
	document.getElementById("ljbuttons").collapsed = false;
	if (isSidebar) {
		document.getElementById("mainbox").orient = "vertical";
		document.getElementById("postoptions").collapsed = true;
	}
	if (dsPrefs.getIntPref("DetectMethod") == 0) {
		document.getElementById("detectmusic").collapsed = true;
	}
	var picalign = ["start", "center", "end"]
	document.getElementById("userpicbox").setAttribute("pack", picalign[dsPrefs.getIntPref("PicAlign")]);
	
	var tbbg = document.defaultView.getComputedStyle(document.getElementById("messagesource"), "").getPropertyValue("background-color");
	var tbfg = document.defaultView.getComputedStyle(document.getElementById("messagesource"), "").getPropertyValue("color");
	var mbox = document.getElementById("message").contentWindow;
	mbox.document.body.style.backgroundColor = tbbg;
	mbox.document.body.style.color = tbfg;
	
	
	ljPost.usejournal = LiveJournal.username;
	
	var pickwlist = document.getElementById("picture");
	pickwlist.appendChild(document.createElement("menupopup"));
	pickwlist.appendItem("[default]", LiveJournal.defaultpicurl);
	for (i = 0; i < LiveJournal.pickws.length; i++) {
		pickwlist.appendItem(LiveJournal.pickws[i].pickw, LiveJournal.pickws[i].url);
	}
	pickwlist.selectedIndex = 0;

	var moodlist = document.getElementById("moods");
	moodlist.appendChild(document.createElement("menupopup"));
	for (i = 0; i < LiveJournal.moods.length; i++) {
		moodlist.appendItem(LiveJournal.moods[i].mood, LiveJournal.moods[i].id);
	}

	document.getElementById("usernametitle").value = LiveJournal.username;
	
	dsPosts.resetPostParameters();
	
	document.getAnonymousNodes(document.getElementById("moods"))[0].addEventListener("focus", dsPosts.moodsGotFocus, true);
	document.getAnonymousNodes(document.getElementById("moods"))[0].addEventListener("blur", dsPosts.moodsLostFocus, true);
	boxesLoseFocus();
	
	Logout = function() {
		parent.ToggleEnabledStuff(true);
		parent.document.getElementById("accounts").setAttribute("disabled", true);
		parent.document.getElementById("loginprogress").mode = "undetermined";
		parent.status.value = "Logging out...";
		parent.document.getElementById("mainwindow").selectedIndex = 0;
		this.httpreq = new XMLHttpRequest();
		this.httpreq.onload = LogoutHandler;
		this.httpreq.onerror = LogoutHandler;
		this.httpreq.open("POST", LiveJournal.posturl, true);
		this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		this.httpreq.setRequestHeader("X-LJ-Auth", "cookie");
		var params = new Object();
		params.user = LiveJournal.username;
		params.auth_method = "cookie";
		params.ver = 1;
		
		var nsiio = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var ljdomain = "http://" + LiveJournal.domain;
		var ljuri = nsiio.newURI(ljdomain, null, null);
		var cookieservice = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieService);
		var cookiestring = cookieservice.getCookieString(ljuri, null);
		var cookiearray = cookiestring.split("; ");
		var ljsessionrx = /ljsession=.*/gi;
		for (i = 0; i < cookiearray.length; i++) {
			if (ljsessionrx.test(cookiearray[i])) {
				// I'm such an awful coder.
				eval("params.expire_id_" + cookiearray[i].split(":")[2] + " = 1;");
				break;
			}
		}
		var body = "mode=sessionexpire";
		body += LiveJournal.makeParams(params);
		dump(body);
		this.httpreq.send(body);
	}
	
	if (!LiveJournal.usetags) {
		document.getElementById("taglist").collapsed = true;
	}
	
	if (parent.accountwindow) {
		InitPosting();
	} else {
		InitEditing();
	}
}

function LogoutHandler() {
	parent.ToggleEnabledStuff(false);
	parent.document.getElementById("accounts").removeAttribute("disabled");
	parent.document.getElementById("loginprogress").mode = "determined";
	parent.status.value = "";
	var nsiio = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var ljuri = "." + LiveJournal.domain;
	var cookiemanager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
	cookiemanager.remove(ljuri, "ljsession", "/", false);
	parent.document.getElementById("dsPostFrame").setAttribute("src", "lib/blank.xul");
}

function InitPosting() {
	// Sets up what is needed for posting.
	// In: Nothing.
	// Out: Nothing.
	var journallist = document.getElementById("usejournal");
	journallist.appendChild(document.createElement("menupopup"));
	journallist.appendItem(LiveJournal.username);
	for (i = 0; i < LiveJournal.usejournals.length; i++) {
		journallist.appendItem(LiveJournal.usejournals[i]);
	}
	journallist.selectedIndex = 0;
	
	var savesecs = dsPrefs.getIntPref("SaveDraftEvery") * 1000;
	if (!isSidebar) {
		dsDraft.loadDraft();
		setInterval("dsDraft.saveDraft();", savesecs);
	}
	document.getElementById("message").contentDocument.designMode = "On";
}

function boxesLoseFocus() {
	// Sets up the pretty little helper boxes.
	dsPosts.fieldLoseFocus(document.getElementById("taglist"), "Tags");
	dsPosts.fieldLoseFocus(document.getElementById("music"), "Current Music");
	dsPosts.moodsLostFocus();
}

function boxesGetFocus() {
	dsPosts.fieldGotFocus(document.getElementById("taglist"));
	dsPosts.fieldGotFocus(document.getElementById("music"));
	dsPosts.moodsGotFocus();
}

// Start of dicking around with moods box.
dsPosts.moodsGotFocus = function() {
	var moods = document.getElementById("moods");
	var obj = document.getAnonymousNodes(moods)[0].firstChild;
	if (obj.getAttribute("class") == "menulist-editable-input emptybox") {
		moods.label = "";
	}
	obj.setAttribute("class", "menulist-editable-input");
}

dsPosts.moodsLostFocus = function() {
	var moods = document.getElementById("moods");
	var obj = document.getAnonymousNodes(moods)[0].firstChild;
	if (moods.label.trim().length < 1) {
		obj.setAttribute("class", "menulist-editable-input emptybox");
		moods.label = "Current Mood";
	}
}
// End of dicking around with moods box.

dsPosts.fieldLoseFocus = function(obj, defaulttext) {
	if (obj.value.trim().length < 1) {
		obj.setAttribute("class", "textbox-input emptybox");
		obj.value = defaulttext;
	}
}

dsPosts.fieldGotFocus = function (obj) {
	if (obj.getAttribute("class") == "textbox-input emptybox") {
		obj.value = null;
	}
	obj.setAttribute("class", "textbox-input");
}

function bing() {
	alert("bing");
}

dsPosts.changeJournal = function(obj) {
	// Sets the ljPost object's usejournal to the currently selected journal.
	// In: The usejournal menu node.
	// Out: Nothing.
	ljPost.usejournal = obj.label;
}

dsPosts.changePicture = function(obj) {
	// Changes the selected pic keyword (and the picture shown in the userpic box).
	// In: The picture menu object.
	// Out: Nothing.
	ljPost.pickw = obj.label;
	document.getElementById("userpic").src = obj.value;	
}

dsPosts.changeSecurity = function(selindex, skipdialog) {
	// Sets the current security, and opens a dialog to choose the filters if skipdialog is false and 'custom'
	//	is selected.
	// In: A number. Taken from the security node. 0 = public, 1 = private, 2 = friends, 3 = custom.
	// Out: Nothing.
	switch (selindex) {
		case 2:
			ljPost.security = selindex;
			ljPost.allowmask = 1;
			break;
		case 3:
			ljPost.security = 2;
			if (!skipdialog) {
				window.openDialog("security.xul","security","chrome,modal",ljPost,LiveJournal);
				if (ljPost.allowmask < 2) {
					document.getElementById("security").selectedIndex = 1;
					ljPost.security = 1;
				}
			}
			break;
		default:
			ljPost.security = selindex;
			break;
	}
}

dsPosts.visitJournal = function() {
	// Opens the currently selected journal in the most recent browser window.
	// In: Nothing.
	// Out: Nothing.
	var domain = FindDomain(LiveJournal.posturl);
	var ljpage = domain + "users/" + ljPost.usejournal;
	dsOpenTopWin(ljpage);
}

dsPosts.selectMood = function() {
	var moodlist = document.getElementById("moods");
	for (m = 0; m < LiveJournal.moods.length; m++) {
		if (moodlist.label == LiveJournal.moods[m].mood) {
			moodlist.selectedIndex = m;
			break;
		}
	}
}

dsPosts.resetPostParameters = function() {
	// Resets all the post values to their defaults, and clears out the subject/message boxes. Use when loading, and
	//	upon completion of a successful post.
	// In: Nothing.
	// Out: Nothing.
	dsMidas.setUpMidas();
	document.getElementById("subject").value = null;
	document.getElementById("security").selectedIndex = parseInt(LiveJournal.defaultsecurity, 10);
	this.changeSecurity(document.getElementById("security").selectedIndex);
	ljPost.allowmask = LiveJournal.defaultgroups;
	ljPost.backdate = LiveJournal.defaultbackdate;
	ljPost.removecomments = LiveJournal.defaultremovecomments;
	ljPost.dontautoformat = LiveJournal.defaultdontautoformat;
	dsMidas.dontautoformat = LiveJournal.defaultdontautoformat
	document.getElementById("picture").selectedIndex = 0;
	document.getElementById("userpic").src = LiveJournal.defaultpicurl;
	document.getElementById("moods").label = null;
	document.getElementById("music").value = null;
	document.getElementById("taglist").value = null;
	boxesLoseFocus();
}

dsPosts.sendPost = function() {
	// Disables everything (well, not everything - menus still work and userpic is still clickable) and starts posting.
	//	Oh, and if this function is called again before the other has completed, it cancels everything.
	// In: Nothing.
	// Out: Nothing.
	if (this.posting) {
		this.posting = false;
		ljPost.httpreq.abort();
		document.getElementById("maindisabler").removeAttribute("disabled");
		document.getElementById("messagedeck").selectedIndex = 0;
		document.getElementById("postbutton").label = "Post";
	} else {
		if (dsPrefs.getBoolPref("SpellCheckOnPost")) {
			// goDoCommand won't work for some reason.
			eval(document.getElementById("cmd_spell").getAttribute("oncommand"));
		}
		var musicbox = document.getElementById("music");
		if ((dsPrefs.getBoolPref("AutoDetectMusic")) && (musicbox.value.trim().length < 1)) {
			var detectedmusic = FindMusic();
			if (detectedmusic.length > 0) {
				musicbox.value = detectedmusic;
			}
		}
		document.getElementById("postbutton").label = "Cancel";
		document.getElementById("maindisabler").setAttribute("disabled", true);
		document.getElementById("statuslabel").value = "Posting...";
		document.getElementById("progressbar").mode = "undetermined";
		document.getElementById("messagedeck").selectedIndex = 1;
		this.posting = true;
		ljPost.postToServer();
	}
}

function ljUser() {
	// Inserts a LJ user tag.
	// In: Nothing.
	// Out: Nothing.
	var usertag = [];
	window.openDialog("insertljuser.xul","insertljuser","chrome,modal",usertag);
	if (usertag[0] != null) {
		var ljuser = "<span class=\"" + usertag[1].value + "\">" + usertag[0] + "</span>&nbsp;";
		document.getElementById("message").contentDocument.execCommand("insertHTML", false, ljuser);
	}
}

function ljCut() {
	// Inserts a LiveJournal cut.
	// In: Nothing.
	// Out: Nothing.
	var cut = prompt("Enter some text to go in the cut, or leave blank", "");
	if (typeof(cut) == "string") {
		var win = document.getElementById("message");
		var ljstart, ljend;
		ljend = "</lj-cut>";
		if (cut.length > 0) {
			ljstart = "<lj-cut text=\"" + cut + "\">";
		} else {
			ljstart = "<lj-cut>";
		}
		var selection = win.contentWindow.getSelection();
		var rangeCount = selection.rangeCount;
		if(rangeCount >= 0) {
			var rangeAt = selection.getRangeAt(0);
			var rangeTwo = document.createRange();
			rangeTwo.setStart(rangeAt.endContainer,rangeAt.endOffset);
			rangeTwo.insertNode(document.createTextNode(ljend));
			rangeAt.insertNode(document.createTextNode(ljstart));
		}
	}
}

function OpenHistoryWindow() {
	// Opens the post history window, if it isn't already opened. Otherwise it just gives it focus.
	// In: Nothing.
	// Out: Nothing.
	var windowmanager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var history = windowmanager.getMostRecentWindow("deepestsender:history"); 
	if (history) {
		history.focus();
	} else {
		window.openDialog("history.xul","dshistory","chrome,dependent", LiveJournal, ljPost);
	}
}

function EditLastEntry() {
	// Opens the edit window, with the most recent entry open.
	// In: Nothing.
	// Out: Nothing.
	var windowwatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	var editwindow = windowwatcher.getWindowByName("dslastentry", null);
	if (editwindow) {
		editwindow.focus();
	} else {
		window.openDialog("livejournal.xul","dslastentry","chrome,resizable,titlebar,dialog=no", LiveJournal, -1, ljPost.usejournal);
	}
}

function OpenPostOptions() {
	// Opens the post options window. If dsAccounts doesn't exist, it doesn't pass it on (defaults can't be saved).
	// In: Nothing.
	// Out: Nothing.
	if (typeof(dsAccounts) != "undefined") {
		window.openDialog("postoptions.xul","dspostoptions","chrome,modal",LiveJournal,dsPosts,window,dsPrefs,ljPost,dsAccounts);
	} else {
		window.openDialog("postoptions.xul","dspostoptions","chrome,modal",LiveJournal,dsPosts,window,dsPrefs,ljPost);
	}
}

function WindowClosing() {
	if ((parent.accountwindow) && (!isSidebar)) {
		dsDraft.saveDraft();
		var nsiio = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var ljuri = "." + LiveJournal.domain;
		var cookiemanager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
		cookiemanager.remove(ljuri, "ljfastserver", "/", false);
	}
}
